8a54ab9a8b71e77788a588742baaec6b6c743b5c
[BK-2020-03.git] / unitproc / bktemp-timeUntilNextHour
1 #!/bin/bash
2 # Desc: Template to report seconds until beginning of next hour
3 # Author: Steven Baltaktei Sandoval; License: GPLv3+
4
5 #==BEGIN Define script parameters==
6 #===BEGIN Declare local script functions===
7 yell() { echo "$0: $*" >&2; } # Yell, Die, Try Three-Fingered Claw technique; # Ref/Attrib: https://stackoverflow.com/a/25515370
8 die() { yell "$*"; exit 111; }
9 try() { "$@" || die "cannot $*"; }
10 timeUntilNextHour(){
11 # Desc: Report seconds until next hour
12 # Output: stdout: integer seconds until next hour
13 # Output: exit code 0 if stdout > 0; 1 if stdout = 0; 2 if stdout < 0
14 # Usage: timeUntilNextHour
15 # Usage: if ! myTTL="$(timeUntilNextHour)"; then yell "ERROR in if statement"; exit 1; fi
16 local returnState TIME_CURRENT TIME_NEXT_HOUR SECONDS_UNTIL_NEXT_HOUR
17 TIME_CURRENT="$(date --iso-8601=seconds)"; # Produce `date`-parsable current timestamp with resolution of 1 second.
18 TIME_NEXT_HOUR="$(date -d "$TIME_CURRENT next hour" --iso-8601=hours)"; # Produce `date`-parsable current time stamp with resolution of 1 second.
19 SECONDS_UNTIL_NEXT_HOUR="$(( $(date +%s -d "$TIME_NEXT_HOUR") - $(date +%s -d "$TIME_CURRENT") ))"; # Calculate seconds until next hour (res. 1 second).
20 if [[ "$SECONDS_UNTIL_NEXT_HOUR" -gt 0 ]]; then
21 returnState="true";
22 elif [[ "$SECONDS_UNTIL_NEXT_HOUR" -eq 0 ]]; then
23 returnState="WARNING_ZERO";
24 yell "WARNING:Reported time until next hour exactly zero.";
25 elif [[ "$SECONDS_UNTIL_NEXT_HOUR" -lt 0 ]]; then
26 returnState="WARNING_NEGATIVE";
27 yell "WARNING:Reported time until next hour is negative.";
28 fi
29
30 try echo "$SECONDS_UNTIL_NEXT_HOUR"; # Report
31
32 #===Determine function return code===
33 if [[ "$returnState" = "true" ]]; then
34 return 0;
35 elif [[ "$returnState" = "WARNING_ZERO" ]]; then
36 return 1;
37 elif [[ "$returnState" = "WARNING_NEGATIVE" ]]; then
38 return 2;
39 fi
40 } # Report seconds until next hour
41 #===END Declare local script functions===
42 #==END Define script parameters==
43
44
45 #==BEGIN sample code==
46 try echo "Time until next hour (seconds):$(timeUntilNextHour)" # simple report
47
48 if ! myTTL="$(timeUntilNextHour)"; then yell "ERROR in if statement for myTTL:$myTTL"; exit 1; fi # Use of exit code to exit early if time <= 0.
49 #==END sample code==